import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Merchant, MerchantParam } from './model';

/**
 * 分页查询商户
 */
export async function pageMerchant(params: MerchantParam) {
  const res = await request.get<ApiResult<PageResult<Merchant>>>(
    '/shop/merchant/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商户列表
 */
export async function listMerchant(params?: MerchantParam) {
  const res = await request.get<ApiResult<Merchant[]>>('/shop/merchant', {
    params
  });
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商户
 */
export async function addMerchant(data: Merchant) {
  const res = await request.post<ApiResult<unknown>>('/shop/merchant', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商户
 */
export async function updateMerchant(data: Merchant) {
  const res = await request.put<ApiResult<unknown>>('/shop/merchant', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商户
 */
export async function removeMerchant(id?: number) {
  const res = await request.delete<ApiResult<unknown>>('/shop/merchant/' + id);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商户
 */
export async function removeBatchMerchant(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>('/shop/merchant/batch', {
    data
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    '/shop/merchant/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
